//
//  ViewController.swift
//  瀑布流
//
//  Created by 吕中威 on 16/5/24.
//  Copyright © 2016年 吕中威. All rights reserved.
//

import UIKit

var layout : WaterCollectionLayout?;
var collection : UICollectionView?;
class ViewController: UIViewController , NSURLSessionDataDelegate , UICollectionViewDelegate ,UICollectionViewDataSource {

    override func viewDidLoad() {
        super.viewDidLoad()
        
        layout = WaterCollectionLayout();
        layout!.columnCount = 3;
        collection = UICollectionView(frame: CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height), collectionViewLayout: layout!);
        collection?.delegate = self;
        collection?.dataSource = self;
        collection?.registerNib(UINib.init(nibName: "CollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "CellID");
        self.view.addSubview(collection!);
        self.creatNetWork();
        // Do any additional setup after loading the view, typically from a nib.
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        
        return  self.dataArray.count;
    }
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        
        return 1;
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("CellID", forIndexPath: indexPath) as! CollectionViewCell;
        let model = self.dataArray[indexPath.item] as! PictureModel;
//        cell.setCellOfUrl(model.isrc!);
        let request = NSURLRequest(URL:NSURL.init(string: model.isrc!)!);
        NSURLConnection.sendAsynchronousRequest(request, queue: NSOperationQueue.mainQueue(), completionHandler: { (response: NSURLResponse?, data : NSData?, error: NSError?) -> Void in
            if(data != nil){
                
                let img = UIImage(data: data!);
                dispatch_async(dispatch_get_main_queue(), {
                    cell.pictureImageView.image = img;
                })
             }
        });
        return cell;
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func creatNetWork()  {
        
        let sessionConfig = NSURLSessionConfiguration.defaultSessionConfiguration();
        let session = NSURLSession(configuration: sessionConfig, delegate: self, delegateQueue: nil);
        let url = NSURL(string:"http://www.duitang.com/album/1733789/masn/p/0/50");
        let request = NSURLRequest(URL: url!);
        let dataTask = session.dataTaskWithRequest(request);
        dataTask.resume();
    }
    
    func URLSession(session: NSURLSession, task: NSURLSessionTask, didCompleteWithError error: NSError?) {
        
        print(error);
    }
    
    func URLSession(session: NSURLSession, dataTask: NSURLSessionDataTask, didReceiveData data: NSData) {
        
        do{
            let dataDic =  try NSJSONSerialization.JSONObjectWithData(data, options: NSJSONReadingOptions.AllowFragments) as? NSDictionary;
            let arr = dataDic!["data"]!["blogs"] as? NSArray;
            
            for i in 0 ..< arr!.count{
                
                let model = PictureModel();
                let dict = arr![i] as! NSDictionary;
                model.isrc = dict["isrc"] as? String;
                model.iht = dict["iht"] as? NSNumber;
                model.iwd = dict["iwd"] as? NSNumber;
                self.dataArray.addObject(model);
            }
            dispatch_sync(dispatch_get_main_queue(), { () -> Void in
                
               collection!.reloadData();
               layout?.initCellBlock({ (waterLayout, width, indexPath) -> CGFloat in
                
                let model = self.dataArray[indexPath.item] as! PictureModel;
                
                return (CGFloat((model.iht! as NSNumber).floatValue) * width / CGFloat((model.iwd! as NSNumber).floatValue)) as CGFloat;
               })
            })
        }catch _ as NSError{
            
        }catch{
            
        }
        
    }

    lazy var dataArray : NSMutableArray = {
    
        let arr = NSMutableArray();
        return arr
    }();

}

