//
//  WaterCollectionLayout.swift
//  瀑布流
//
//  Created by 吕中威 on 16/5/24.
//  Copyright © 2016年 吕中威. All rights reserved.
//

import UIKit


typealias CellHightBlock = (layout :WaterCollectionLayout,width:CGFloat,index:NSIndexPath) -> CGFloat;



class WaterCollectionLayout: UICollectionViewFlowLayout {
  
    var columnCount : Int?;
    
    var cellHightBlock : CellHightBlock?;
    override func prepareLayout() {
        
        super.prepareLayout();
        
        for i in 0 ..< columnCount! {
            
            let key = "\(Float(i))";
            self.maxYDict[key] = "\(self.sectionInset.top)";
        }
        
        self.dataArray.removeAllObjects();
        let count = self.collectionView?.numberOfItemsInSection(0);
        
        for i in 0 ..< count! {
            
            let indexPath = NSIndexPath.init(forItem: i, inSection: 0);
            let attrs = self.layoutAttributesForItemAtIndexPath(indexPath);
            self.dataArray.addObject(attrs!);
        }
    }
    
    override func collectionViewContentSize() -> CGSize {
        
        super.collectionViewContentSize();
        let maxKey = self.maxColumn();
        let hight = CGFloat((self.maxYDict[maxKey]?.floatValue)!)
        return CGSizeMake(0, hight);
    }
    
    override func layoutAttributesForElementsInRect(rect: CGRect) -> [UICollectionViewLayoutAttributes]? {
        
        super.layoutAttributesForElementsInRect(rect);
        return (self.dataArray as NSArray as! [UICollectionViewLayoutAttributes]);
    }
    
    override func layoutAttributesForItemAtIndexPath(indexPath: NSIndexPath) -> UICollectionViewLayoutAttributes? {
        
        let contentWidth = self.collectionView?.bounds.size.width ;
        let kongxiWidth =   self.sectionInset.left + self.sectionInset.right +  CGFloat(columnCount! - 1) * self.minimumInteritemSpacing ;
        let cellWidth = (contentWidth! - kongxiWidth ) /  CGFloat(columnCount!);
            
        let cellHight = cellHightBlock!(layout: self,width: cellWidth,index: indexPath);
        
        let col = CGFloat((self.minColumn() as NSString).floatValue);
        let cellX = (cellWidth + self.minimumInteritemSpacing) * col;
        
        let colStr = "\(col)"
        let maxY = self.maxYDict[colStr];
        let cellY = CGFloat((maxY?.floatValue)!);
        
        let nextMaxY =  cellY + cellHight + self.minimumLineSpacing;
        self.maxYDict[colStr] = "\(nextMaxY)"
        
        let attrs = UICollectionViewLayoutAttributes(forCellWithIndexPath: indexPath);
        attrs.frame = CGRect(x: cellX, y: cellY, width: cellWidth, height: cellHight);
        
        return attrs;
    }
    
    func initCellBlock(cellBlock : (waterLayout : WaterCollectionLayout,width:CGFloat,indexPath : NSIndexPath) -> CGFloat){
        
        cellHightBlock = cellBlock;
        
    }
    
    // 获取字典中的最大值
    func maxColumn() -> String{
        
        var maxKey = "\(0.0)";
        self.maxYDict.enumerateKeysAndObjectsUsingBlock { (key, value,stop) -> Void in
         
            if self.maxYDict[maxKey]?.floatValue > value.floatValue{
                
               
            }else{
                
                maxKey = key as! String;
            }
        };
        return maxKey;
    }
    
    // 获取字典中的最小值
    func minColumn() -> String{
        
        var minKey = "\(0.0)";
        self.maxYDict.enumerateKeysAndObjectsUsingBlock { (key, value,stop) -> Void in
            
            if self.maxYDict[minKey]?.floatValue > value.floatValue{
                
                minKey = key as! String;
            }
        };
        return minKey;
    }
    
    lazy var dataArray : NSMutableArray = {
        
        let arr = NSMutableArray();
        return arr;
    }();
    lazy var maxYDict  : NSMutableDictionary = {
        
        let dict = NSMutableDictionary();
        return dict;
    }();
    
}

